diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
index 6d320a13..4b79af1c 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
@@ -1060,83 +1089,96 @@ class LdapServer {
   }
 
 	/**
-	 * @param ldap entry array $ldap_entry
+	 * @param array $ldap_entry
 	 *
-	 * @return drupal file object image user's thumbnail or FALSE if none present or ERROR happens.
+	 * @return object|bool
+   *   Drupal file object image user's thumbnail or FALSE if none present or
+   *   ERROR happens.
 	 */
 	public function userPictureFromLdapEntry($ldap_entry, $drupal_username = FALSE) {
 		if ($ldap_entry && $this->picture_attr) {
 			//Check if ldap entry has been provisioned.
 
-			$thumb = isset($ldap_entry[$this->picture_attr][0]) ? $ldap_entry[$this->picture_attr][0] : FALSE;
-			if(!$thumb){
+			$image_data = isset($ldap_entry[$this->picture_attr][0]) ? $ldap_entry[$this->picture_attr][0] : FALSE;
+			if (!$image_data) {
 				return FALSE;
 			}
 
-			//Create md5 check.
-			$md5thumb = md5($thumb);
+			$md5thumb = md5($image_data);
 
 			/**
-			 * If existing account already has picture check if it has changed if so remove old file and create the new one
-		   * If picture is not set but account has md5 something is wrong exit.
+			 * If the existing account already has picture check if it has changed. If
+       * so remove the old file and create the new one. If a picture is not set
+       * but the account has an md5 hash, something is wrong and we exit.
 			 */
 			if ($drupal_username && $account = user_load_by_name($drupal_username)) {
-        if ($account->uid == 0 || $account->uid == 1){
+        if ($account->uid == 0 || $account->uid == 1) {
           return FALSE;
         }
-        if (isset($account->picture)){
-          // Check if image has changed
-          if (isset($account->data['ldap_user']['init']['thumb5md']) && $md5thumb === $account->data['ldap_user']['init']['thumb5md']){
-            //No change return same image
+        if (isset($account->picture)) {
+          // Check if image has changed.
+          if (isset($account->data['ldap_user']['init']['thumb5md']) && $md5thumb === $account->data['ldap_user']['init']['thumb5md']) {
+            // No change, return same image.
+            $account->picture->md5Sum = $md5thumb;
             return $account->picture;
           }
           else {
-            //Image is different check wether is obj/str and remove fileobject
-            if (is_object($account->picture)){
+            // Image is different, remove file object.
+            if (is_object($account->picture)) {
               file_delete($account->picture, TRUE);
             }
-            elseif (is_string($account->picture)){
+            elseif (is_string($account->picture)) {
               $file = file_load(intval($account->picture));
               file_delete($file, TRUE);
             }
           }
         }
         elseif (isset($account->data['ldap_user']['init']['thumb5md'])) {
-          watchdog('ldap_server', "Some error happened during thumbnailPhoto sync");
+          watchdog('ldap_servers', "Some error happened during thumbnailPhoto sync.");
           return FALSE;
         }
       }
-			//Create tmp file to get image format.
-			$filename = uniqid();
-			$fileuri = file_directory_temp() .'/'. $filename;
-			$size = file_put_contents($fileuri, $thumb);
-			$info = image_get_info($fileuri);
-			unlink($fileuri);
-			// create file object
-			$file = file_save_data($thumb, 'public://' . variable_get('user_picture_path') .'/'. $filename .'.'. $info['extension']);
-			$file->md5Sum = $md5thumb;
-			// standard Drupal validators for user pictures
-			$validators = array(
-					'file_validate_is_image' => array(),
-					'file_validate_image_resolution' => array(variable_get('user_picture_dimensions', '85x85')),
-					'file_validate_size' => array(variable_get('user_picture_file_size', '30') * 1024),
-			);
-			$errors = file_validate($file ,$validators);
-			if (empty($errors)) {
-				return $file;
-			}
-      else {
-				foreach ($errors as $err => $err_val){
-					watchdog('ldap_server', "Error storing picture: %$err", array("%$err" => $err_val), WATCHDOG_ERROR);
-				}
-				return FALSE;
-			}
-		}
+      return $this->savePictureData($image_data, $md5thumb);
+    }
+    return FALSE;
 	}
 
 
   /**
-   * @param ldap entry array $ldap_entry
+   * @param $image_data
+   * @param $md5thumb
+   */
+  private function savePictureData($image_data, $md5thumb) {
+    //Create tmp file to get image format.
+    $filename = uniqid();
+    $fileuri = file_directory_temp() . '/' . $filename;
+    $size = file_put_contents($fileuri, $image_data);
+    $info = image_get_info($fileuri);
+    unlink($fileuri);
+    // create file object
+    $file = file_save_data($image_data, file_default_scheme() . '://' . variable_get('user_picture_path') . '/' . $filename . '.' . $info['extension']);
+    $file->md5Sum = $md5thumb;
+    // standard Drupal validators for user pictures
+    $validators = [
+      'file_validate_is_image' => [],
+      'file_validate_image_resolution' => [variable_get('user_picture_dimensions', '85x85')],
+      'file_validate_size' => [variable_get('user_picture_file_size', '30') * 1024],
+    ];
+    $errors = file_validate($file, $validators);
+    if (empty($errors)) {
+      return $file;
+    }
+    else {
+      foreach ($errors as $err => $err_val) {
+        watchdog('ldap_servers', "Error storing picture: %error", ["%error" => $err_val], WATCHDOG_ERROR);
+      }
+      return FALSE;
+    }
+  }
+
+
+  /**
+   * @param array $ldap_entry
    *
    * @return string user's PUID or permanent user id (within ldap), converted from binary, if applicable
    */
@@ -1159,7 +1201,7 @@ class LdapServer {
     }
   }
 
-   /**
+  /**
    *  @param mixed $user
    *    - drupal user object (stdClass Object)
    *    - ldap entry of user (array)
@@ -1167,7 +1209,7 @@ class LdapServer {
    *    - drupal username of user (string)
    *
    *  @return array $ldap_user_entry (with top level keys of 'dn', 'mail', 'sid' and 'attr' )
-  */
+   */
   public function user_lookup($user) {
     return $this->userUserToExistingLdapEntry($user);
   }
@@ -1206,7 +1248,7 @@ class LdapServer {
    *   'attr' => single ldap entry array in form returned from ldap_search() extension, e.g.
    *   'dn' => dn of entry
    */
-  function userUserNameToExistingLdapEntry($drupal_user_name, $ldap_context = NULL) {
+  public function userUserNameToExistingLdapEntry($drupal_user_name, $ldap_context = NULL) {
 
     $watchdog_tokens = array('%drupal_user_name' => $drupal_user_name);
     $ldap_username = $this->userUsernameToLdapNameTransform($drupal_user_name, $watchdog_tokens);
@@ -1252,7 +1294,7 @@ class LdapServer {
       else {
         if ($this->bind_method == LDAP_SERVERS_BIND_METHOD_ANON_USER) {
           $result = array(
-            'dn' =>  $match['dn'],
+            'dn' => $match['dn'],
             'mail' => $this->userEmailFromLdapEntry($match),
             'attr' => $match,
             'sid' => $this->sid,
@@ -1275,7 +1317,7 @@ class LdapServer {
       foreach ($match[$name_attr] as $value) {
         if (drupal_strtolower(trim($value)) == drupal_strtolower($ldap_username)) {
           $result = array(
-            'dn' =>  $match['dn'],
+            'dn' => $match['dn'],
             'mail' => $this->userEmailFromLdapEntry($match),
             'attr' => $match,
             'sid' => $this->sid,
@@ -1306,8 +1348,6 @@ class LdapServer {
     return (is_array($group_dns) && in_array(drupal_strtolower($group_dn), $this->dnArrayToLowerCase($group_dns)));
   }
 
-
-
   /**
    * NOT TESTED
    * add a group entry
@@ -1475,7 +1515,7 @@ class LdapServer {
 
   }
 
-/**
+  /**
    *   NOT IMPLEMENTED
    * recurse through all child groups and add members.
    *
@@ -1488,7 +1528,6 @@ class LdapServer {
    * @param int $max_levels as max recursion allowed
    *
    */
-
   public function groupMembersResursive($current_member_entries, &$all_member_dns, &$tested_group_ids, $level, $max_levels, $object_classes = FALSE) {
 
     if (!$this->groupGroupEntryMembershipsConfigured || !is_array($current_member_entries) || count($current_member_entries) == 0) {
@@ -1523,7 +1562,7 @@ class LdapServer {
           };
           $ors = array();
           foreach ($member_ids as $i => $member_id) {
-            $ors[] =  $this->groupMembershipsAttr . '=' . ldap_pear_escape_filter_value($member_id); // @todo this would be replaced by query template
+            $ors[] = $this->groupMembershipsAttr . '=' . ldap_pear_escape_filter_value($member_id); // @todo this would be replaced by query template
           }
 
           if (count($ors)) {
@@ -1548,7 +1587,6 @@ class LdapServer {
   }
 
 
- /**
   /**
    *  get list of all groups that a user is a member of.
    *
@@ -1569,7 +1607,6 @@ class LdapServer {
    *
    *  @return array of groups dns in mixed case or FALSE on error
    */
-
   public function groupMembershipsFromUser($user, $return = 'group_dns', $nested = NULL) {
 
     $group_dns = FALSE;
@@ -1618,7 +1655,6 @@ class LdapServer {
    *
    *  @return array of group dns
    */
-
   public function groupUserMembershipsFromUserAttr($user, $nested = NULL) {
 
     if (!$this->groupUserMembershipsConfigured) {
@@ -1656,13 +1692,13 @@ class LdapServer {
         else {
           $member_value = ldap_servers_get_first_rdn_value_from_dn($member_group_dn, $this->groupMembershipsAttrMatchingUserAttr);
         }
-        $ors[] =  $this->groupMembershipsAttr . '=' . ldap_pear_escape_filter_value($member_value);
+        $ors[] = $this->groupMembershipsAttr . '=' . ldap_pear_escape_filter_value($member_value);
       }
     }
 
     if ($nested && count($ors)) {
       $count = count($ors);
-      for ($i=0; $i < $count; $i=$i+LDAP_SERVER_LDAP_QUERY_CHUNK) { // only 50 or so per query
+      for ($i = 0; $i < $count; $i = $i + LDAP_SERVER_LDAP_QUERY_CHUNK) { // only 50 or so per query
         $current_ors = array_slice($ors, $i, LDAP_SERVER_LDAP_QUERY_CHUNK);
         $or = '(|(' . join(")(", $current_ors) . '))';  // e.g. (|(cn=group1)(cn=group2)) or   (|(dn=cn=group1,ou=blah...)(dn=cn=group2,ou=blah...))
         $query_for_parent_groups = '(&(objectClass=' . $this->groupObjectClass . ')' . $or . ')';
@@ -1758,7 +1794,6 @@ class LdapServer {
    *
    * @return FALSE for error or misconfiguration, otherwise TRUE.  results are passed by reference.
    */
-
   public function groupMembershipsFromEntryRecursive($current_group_entries, &$all_group_dns, &$tested_group_ids, $level, $max_levels) {
 
     if (!$this->groupGroupEntryMembershipsConfigured || !is_array($current_group_entries) || count($current_group_entries) == 0) {
@@ -1777,21 +1812,21 @@ class LdapServer {
         $member_id = ldap_servers_get_first_rdn_value_from_dn($group_entry['dn'], $this->groupMembershipsAttrMatchingUserAttr);
 	if(!$member_id) {
 	  if ($this->detailed_watchdog_log) {
-	     watchdog('ldap_server', 'group_entry: %ge', array('%ge'=>pretty_print_ldap_entry($group_entry)));
+	     watchdog('ldap_servers', 'group_entry: %ge', array('%ge' => pretty_print_ldap_entry($group_entry)));
 	  }
 	  // group not identified by simple checks yet!
 
 	  // examine the entry and see if it matches the configured groupObjectClass
-	  $goc=$group_entry['objectclass']; // TODO do we need to ensure such entry is there?
+	  $goc = $group_entry['objectclass']; // TODO do we need to ensure such entry is there?
 	  if(is_array($goc)) {              // TODO is it always an array?
 	    foreach($goc as $g) {
-	      $g=drupal_strtolower($g);
+	      $g = drupal_strtolower($g);
 	      if($g == $this->groupObjectClass) {
 		// found a group, current user must be member in it - so:
 		if ($this->detailed_watchdog_log) {
-		  watchdog('ldap_server', 'adding %mi', array('%mi'=>$member_id));
+		  watchdog('ldap_servers', 'adding %mi', array('%mi' => $member_id));
 		}
-		$member_id=$group_entry['dn'];
+		$member_id = $group_entry['dn'];
 		break;
 	      }
 	    }
@@ -1803,13 +1838,13 @@ class LdapServer {
         $tested_group_ids[] = $member_id;
         $all_group_dns[] = $group_entry['dn'];
         // add $group_id (dn, cn, uid) to query
-        $ors[] =  $this->groupMembershipsAttr . '=' .  ldap_pear_escape_filter_value($member_id);
+        $ors[] = $this->groupMembershipsAttr . '=' .  ldap_pear_escape_filter_value($member_id);
       }
     }
 
     if ($level < $max_levels && count($ors)) {
       $count = count($ors);
-      for ($i=0; $i < $count; $i=$i+LDAP_SERVER_LDAP_QUERY_CHUNK) { // only 50 or so per query
+      for ($i = 0; $i < $count; $i = $i + LDAP_SERVER_LDAP_QUERY_CHUNK) { // only 50 or so per query
         $current_ors = array_slice($ors, $i, LDAP_SERVER_LDAP_QUERY_CHUNK);
         $or = '(|(' . join(")(", $current_ors) . '))';  // e.g. (|(cn=group1)(cn=group2)) or   (|(dn=cn=group1,ou=blah...)(dn=cn=group2,ou=blah...))
         $query_for_parent_groups = '(&(objectClass=' . $this->groupObjectClass . ')' . $or . ')';
@@ -1827,8 +1862,8 @@ class LdapServer {
   }
 
 
- /**
-   *  get "groups" from derived from DN.  Has limited usefulness
+  /**
+   * Get "groups" from derived from DN.  Has limited usefulness
    *
    *  @param mixed
    *    - drupal user object (stdClass Object)
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.admin.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.admin.inc
index 8f5e397e..23ee1d8e 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.admin.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.admin.inc
@@ -23,7 +23,7 @@ function ldap_servers_edit_index() {
  */
 function ldap_servers_servers_list($sid = NULL, $actions = FALSE) {
 
-  $variables =  array(
+  $variables = array(
     'ldap_servers' => $ldap_server = ldap_servers_get_servers($sid, 'all'),
     'action' => TRUE,
     'type' => 'table',
@@ -168,7 +168,7 @@ function ldap_servers_admin_delete_submit($form, &$form_state) {
     if ($result = $ldap_server->delete($sid)) {
       $tokens = array('%name' => $ldap_server->name, '!sid' => $sid);
       drupal_set_message(t('LDAP Server %name (server id = !sid) has been deleted.', $tokens), 'status');
-      watchdog('ldap', 'LDAP Server deleted: %name (sid = !sid) ', $tokens);
+      watchdog('ldap_servers', 'LDAP Server deleted: %name (sid = !sid) ', $tokens);
     }
     else {
       drupal_set_message(t('LDAP Server delete failed.'), 'warning');
@@ -217,7 +217,7 @@ function ldap_servers_admin_enable_disable($form, &$form_state, $action = NULL,
     );
     return confirm_form(
       $form,
-      t('Are you sure you want to') . t($action) . ' ' . t('the LDAP server named <em><strong>%name</strong></em>?', array('%name' =>  $ldap_server->name)),
+      t('Are you sure you want to') . t($action) . ' ' . t('the LDAP server named <em><strong>%name</strong></em>?', array('%name' => $ldap_server->name)),
       LDAP_SERVERS_MENU_BASE_PATH . '/servers/list',
       t('<p></p>'),
       t($action),
@@ -244,7 +244,7 @@ function ldap_servers_admin_enable_disable_submit($form, &$form_state) {
     $tokens = array('%name' => $values['name'], '!sid' => $sid, '!action' => t($values['action']) . 'd');
     drupal_set_message(t('LDAP Server Configuration %name (server id = !sid) has been !action.', $tokens));
     $message = t('LDAP Server !action: %name (sid = !sid) ', $tokens);
-    watchdog('ldap', $message);
+    watchdog('ldap_servers', $message);
 
   }
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
index 33428463..343fddda 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
@@ -3,6 +3,7 @@ description = Implements LDAP Server Configuration
 package = Lightweight Directory Access Protocol
 dependencies[] = ctools
 core = 7.x
+php = 5.4
 
 files[] = LdapServer.class.php
 files[] = LdapServerAdmin.class.php
@@ -17,9 +18,8 @@ files[] = ldap_servers.theme.inc
 files[] = tests/ldap_servers.test
 configure = admin/config/people/ldap/servers
 
-; Information added by Drupal.org packaging script on 2017-08-27
-version = "7.x-2.3"
+; Information added by Drupal.org packaging script on 2018-08-13
+version = "7.x-2.4"
 core = "7.x"
 project = "ldap"
-datestamp = "1503841448"
-
+datestamp = "1534201086"
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
index 6317762a..71e925e0 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
@@ -1,5 +1,9 @@
 <?php
 
+/**
+ * @file
+ */
+
 define('LDAP_SERVER_LDAP_QUERY_CHUNK', 50);
 define('LDAP_SERVERS_MAXFILTER_ORS', 30);
 define('LDAP_SERVER_LDAP_QUERY_RECURSION_LIMIT', 10);
@@ -139,14 +143,16 @@ define('LDAP_MORE_RESULTS_TO_RETURN', 0x5f);
 define('LDAP_CLIENT_LOOP', 0x60);
 define('LDAP_REFERRAL_LIMIT_EXCEEDED', 0x61);
 
-require_once('ldap_servers.functions.inc');
-require_once('ldap_servers.tokens.inc');
+module_load_include('inc', 'ldap_servers', 'ldap_servers.functions');
+module_load_include('inc', 'ldap_servers', 'ldap_servers.tokens');
 
 /**
  * Implements hook_init().
  */
 function ldap_servers_init() {
-  drupal_add_css(drupal_get_path('module', 'ldap_servers') . '/ldap_servers.admin.css', 'module');
+  if (strpos(current_path(), 'admin/config/people/ldap') === 0) {
+    drupal_add_css(drupal_get_path('module', 'ldap_servers') . '/ldap_servers.admin.css', 'module');
+  }
 }
 
 /**
@@ -378,7 +384,7 @@ function ldap_servers_ldap_user_attrs_list_alter(&$available_user_attrs, &$param
         }
       }
 
-      $available_user_attrs['[field.ldap_user_puid_sid]'] =  array(
+      $available_user_attrs['[field.ldap_user_puid_sid]'] = array(
         'name' => t('Field: sid providing PUID'),
         'configurable_to_drupal' => 0,
         'configurable_to_ldap' => 1,
@@ -391,7 +397,7 @@ function ldap_servers_ldap_user_attrs_list_alter(&$available_user_attrs, &$param
         'prov_module' => 'ldap_user',
       ) + $available_user_attrs['[field.ldap_user_puid_sid]'];
 
-      $available_user_attrs['[field.ldap_user_puid]'] =  array(
+      $available_user_attrs['[field.ldap_user_puid]'] = array(
         'name' => t('Field: PUID', $tokens),
         'configurable_to_drupal' => 0,
         'configurable_to_ldap' => 1,
@@ -410,7 +416,7 @@ function ldap_servers_ldap_user_attrs_list_alter(&$available_user_attrs, &$param
         'name' => t('Field: PUID Attribute', $tokens),
         'configurable_to_drupal' => 0,
         'configurable_to_ldap' => 1,
-        'source' =>  $ldap_server->unique_persistent_attr ,
+        'source' => $ldap_server->unique_persistent_attr ,
         'notes' => 'configure at ' . $server_edit_path,
         'direction' => LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER,
         'enabled' => TRUE,
@@ -455,7 +461,7 @@ function ldap_servers_ldap_user_attrs_list_alter(&$available_user_attrs, &$param
       if (!isset($available_user_attrs['[property.mail]']) || !is_array($available_user_attrs['[property.mail]'])) {
         $available_user_attrs['[property.mail]'] = array();
       }
-      $available_user_attrs['[property.mail]'] =  array(
+      $available_user_attrs['[property.mail]'] = array(
         'name' => 'Property: Email',
         'source' => ($ldap_server->mail_template) ? $ldap_server->mail_template : '[' . $ldap_server->mail_attr . ']',
         'direction' => LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER,
@@ -899,31 +905,31 @@ function ldap_servers_ldap_servers_types() {
 
   $path = drupal_get_path('module', 'ldap_servers') . '/ldap_types';
 
-  $types['default'] =  array(
+  $types['default'] = array(
     'class' => t('LdapTypeDefault'),
     'directory_path' => $path,
     'name' => 'Default LDAP',
   );
 
-  $types['ad'] =  array(
+  $types['ad'] = array(
     'class' => t('LdapTypeActiveDirectory'),
     'directory_path' => $path,
     'name' => 'Active Directory',
   );
 
-  $types['novell_edir'] =  array(
+  $types['novell_edir'] = array(
     'class' => t('LdapTypeNovell'),
     'directory_path' => $path,
     'name' => 'Novell',
   );
 
-  $types['openldap'] =  array(
+  $types['openldap'] = array(
     'class' => t('LdapTypeOpenLdap'),
     'directory_path' => $path,
     'name' => 'Open LDAP',
   );
 
-  $types['opendir'] =  array(
+  $types['opendir'] = array(
     'class' => t('LdapTypeOpenDirectory'),
     'directory_path' => $path,
     'name' => 'Apple Open Directory',
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
index a8756333..29a0b0dc 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
@@ -1,5 +1,9 @@
 <?php
 
+/**
+ * @file
+ */
+
 module_load_include('inc', 'ldap_servers', 'ldap_servers.functions');
 
 /**
@@ -87,7 +91,7 @@ function ldap_servers_test_form($form, &$form_state, $op = NULL, $sid = NULL) {
     '#description' => t('This is optional and used for testing this server\'s group configuration.'),
   );
 
-  if ($ldap_server->bind_method ==  LDAP_SERVERS_BIND_METHOD_ANON_USER) {
+  if ($ldap_server->bind_method == LDAP_SERVERS_BIND_METHOD_ANON_USER) {
     $form['testing_drupal_userpw'] = array(
       '#type' => 'password',
       '#title' => t('Testing Drupal User Password'),
@@ -136,14 +140,26 @@ function ldap_servers_test_form($form, &$form_state, $op = NULL, $sid = NULL) {
           dpm("Drupal user entity for: $user_name");
           dpm($user_entity);
         }
-       dpm("Test Group LDAP Entry");
-       dpm($test_data['group_entry'][0]);
+        if (isset($test_data['group_entry'][0])) {
+          dpm("Test Group LDAP Entry");
+          dpm($test_data['group_entry'][0]);
+        }
       }
     }
   }
   return $form;
 }
 
+function ldap_servers_string_binary_check($input) {
+  if (preg_match('~[^\x20-\x7E\t\r\n]~', $input) > 0) {
+    $truncatedString = truncate_utf8($input, 200);
+    return t('Binary (excerpt): @excerpt', ['@excerpt' => $truncatedString]);
+  }
+  else {
+    return $input;
+  }
+}
+
 /**
  * Validate hook for the LDAP server form.
  */
@@ -186,7 +202,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
 
   if ($ldap_server->bind_method == LDAP_SERVERS_BIND_METHOD_SERVICE_ACCT) {
     $results_tables['basic'][] = array(t('Binding with DN for non-anonymous search (%bind_dn).  Using password ',
-      array('%bind_dn' =>  $ldap_server->binddn)) . ' ' . $bindpw_type);
+      array('%bind_dn' => $ldap_server->binddn)) . ' ' . $bindpw_type);
   }
   else {
     $results_tables['basic'][] = array(t('Binding with null DN for anonymous search.'));
@@ -215,13 +231,13 @@ function ldap_servers_test_form_submit($form, &$form_state) {
 
     // 3. add group
     $result = $ldap_server->groupAddGroup($group_create_test_dn, $group_create_test_attr);
-    $result = ($result)  ? "PASS" : 'FAIL';
+    $result = ($result) ? "PASS" : 'FAIL';
     $attr = serialize($group_create_test_attr);
     $results_tables['group1'][] = array("LdapServer::groupAddGroup($group_create_test_dn, $attr)", $result);
 
     // 4. call to all members in an empty group returns emtpy array, not FALSE
     $result = $ldap_server->groupAllMembers($group_create_test_dn);
-    $result = (is_array($result) && count($result) == 0)  ? 'PASS' : 'FAIL';
+    $result = (is_array($result) && count($result) == 0) ? 'PASS' : 'FAIL';
     $results_tables['group1'][] = array("LdapServer::groupAllMembers($group_create_test_dn) returns empty array for empty group ", $result);
 
     // 5. add member to group
@@ -243,7 +259,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
 
     $only_if_group_empty = TRUE;
     $result = $ldap_server->groupRemoveGroup($group_create_test_dn, $only_if_group_empty);
-    $result = ($ldap_server->dnExists($group_create_test_dn, 'ldap_entry', array('cn', 'member'))) ?  "FAIL" : 'PASS';
+    $result = ($ldap_server->dnExists($group_create_test_dn, 'ldap_entry', array('cn', 'member'))) ? "FAIL" : 'PASS';
     $results_tables['group1'][] = array("LdapServer::groupRemoveGroup($group_create_test_dn, $only_if_group_empty)", $result);
   }
 
@@ -260,10 +276,10 @@ function ldap_servers_test_form_submit($form, &$form_state) {
           $mapping[] = "$key = " . $value[0];
         }
       }
-      $results_tables['basic'][] =  array(theme_item_list(array('items' => $mapping, 'title' => t('Attributes available to anonymous search', array('%bind_dn' =>  $ldap_server->binddn)) , 'type' => 'ul', 'attributes' => array())));
+      $results_tables['basic'][] = array(theme_item_list(array('items' => $mapping, 'title' => t('Attributes available to anonymous search', array('%bind_dn' => $ldap_server->binddn)) , 'type' => 'ul', 'attributes' => array())));
     }
     $results_tables['basic'][] = array(t('Binding with DN (%bind_dn).  Using supplied password ',
-      array('%bind_dn' =>  $ldap_user['dn'])));
+      array('%bind_dn' => $ldap_user['dn'])));
     $result = $ldap_server->bind($ldap_user['dn'], $values['testing_drupal_userpw'], FALSE);
     if ($result == LDAP_SUCCESS) {
       $results_tables['basic'][] = array(t('Successfully bound to server'), 'PASS');
@@ -295,7 +311,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
 
         if ($ldap_server->groupUserMembershipsConfigured) {
           $groupusermembershipsfromuserattr = $ldap_server->groupUserMembershipsFromUserAttr($user, $nested);
-          $count =  count($groupusermembershipsfromuserattr);
+          $count = count($groupusermembershipsfromuserattr);
           $result = theme('item_list', array('items' => $groupusermembershipsfromuserattr, 'type' => 'ul'));
         }
         else {
@@ -338,7 +354,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
 
   $tokens = ($ldap_user && isset($ldap_user['attr'])) ? ldap_servers_token_tokenize_entry($ldap_user['attr'], 'all') : array();
   foreach ($tokens as $key => $value) {
-    $results_tables['tokens'][] = array($key, $value);
+    $results_tables['tokens'][] = array($key, ldap_servers_string_binary_check($value));
   }
   $form_state['ldap_server_test_data'] = array(
     'username' => $values['testing_drupal_username'],
@@ -352,7 +368,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
   if (isset($group_entry) ) {
     $form_state['ldap_server_test_data']['group_entry'] = $group_entry;
   }
-  
+
 }
 
 /**
@@ -375,7 +391,7 @@ function ldap_servers_test_binding_credentials(&$ldap_server, $bindpw, &$results
   if (!$errors) {
     $bind_result = $ldap_server->bind($ldap_server->binddn, $bindpw, FALSE);
     if ($bind_result == LDAP_SUCCESS) {
-      $results_tables['basic'][] =  array(t('Successfully bound to server'));
+      $results_tables['basic'][] = array(t('Successfully bound to server'));
     }
     else {
       $results_tables['basic'][] = array(t('Failed to bind to server. ldap error #') . $bind_result . ' ' . $ldap_server->errorMsg('ldap')) ;
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.theme.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.theme.inc
index d665c7b0..28eb34dc 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.theme.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.theme.inc
@@ -34,7 +34,7 @@ function theme_ldap_servers_list($variables) {
   }
   if (count($ldap_servers)) {
     foreach ($ldap_servers as $sid => $ldap_server ) {
-      $row =  array(
+      $row = array(
         $ldap_server->name,
         $ldap_server->ldap_type,
         ($ldap_server->status == 1) ? "Yes" : "No",
@@ -140,7 +140,7 @@ function theme_ldap_server_ldap_entry_table($variables) {
         else {
           $token = "";
         }
-        $rows[] = array('data' => array($key, $i, $value2, $token));
+        $rows[] = array('data' => array($key, $i, ldap_servers_string_binary_check($value2), $token));
       }
     }
   }
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.tokens.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.tokens.inc
index 53367bd7..38a09079 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.tokens.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.tokens.inc
@@ -96,7 +96,7 @@ function ldap_servers_token_replace($resource, $text, $resource_type = 'ldap_ent
  *
  * by reference return add ldap attribute triplet $attribute_maps[<attr_name>] = (<attr_name>, <ordinal>, <data_type>) to $attributes
  */
-function ldap_servers_token_extract_attributes(&$attribute_maps,  $text) {
+function ldap_servers_token_extract_attributes(&$attribute_maps, $text) {
   $tokens = ldap_servers_token_tokens_needed_for_template($text);
   foreach ($tokens as $token) {
     $token = str_replace(array(LDAP_SERVERS_TOKEN_PRE, LDAP_SERVERS_TOKEN_POST), array('', ''), $token);
@@ -164,15 +164,21 @@ should return tokens such as:
     [cn] = jdoe
     [cn:0] = jdoe
     [cn:last] => jdoe
+    [cn:reverse:0] = jdoe
     [ou] = campus accounts
     [ou:0] = campus accounts
     [ou:1] = toledo campus
     [ou:last] = toledo campus
+    [ou:reverse:0] = toledo campus
+    [ou:reverse:1] = campus accounts
     [dc] = ad
     [dc:0] = ad
     [dc:1] = myuniversity
     [dc:2] = edu
     [dc:last] = edu
+    [dc:reverse:0] = edu
+    [dc:reverse:1] = myuniversity
+    [dc:reverse:2] = ad
 
     -- from other attributes
     [mail] = jdoe@myuniversity.edu
@@ -237,6 +243,15 @@ function ldap_servers_token_tokenize_entry($ldap_entry, $token_keys = 'all', $pr
     $parts_count[$attr_name]++;
   }
 
+  // Add the parts in reverse order to reflect the hierarchy.
+  foreach ($parts_count as $part => $count) {
+    $part = strtolower($part);
+    for ($i = 0; $i < $count; $i++) {
+      $reverse_position = $count - $i - 1;
+      $tokens[$pre . $part . LDAP_SERVERS_TOKEN_DEL . 'reverse' . LDAP_SERVERS_TOKEN_DEL . $reverse_position . $post] = $tokens[$pre . $part . LDAP_SERVERS_TOKEN_DEL . $i . $post];
+    }
+  }
+
   foreach ($parts_count as $attr_name => $count) {
     $tokens[$pre . ldap_server_massage_text($attr_name, 'attr_name', LDAP_SERVER_MASSAGE_TOKEN_REPLACE) . LDAP_SERVERS_TOKEN_DEL . 'last' . $post] = $parts_last_value[$attr_name];
   }
@@ -253,8 +268,8 @@ function ldap_servers_token_tokenize_entry($ldap_entry, $token_keys = 'all', $pr
         $tokens[$pre . ldap_server_massage_text($attr_name, 'attr_name', LDAP_SERVER_MASSAGE_TOKEN_REPLACE) . LDAP_SERVERS_TOKEN_DEL . 'last' . $post] = check_plain($attr_value[0]);
       }
       elseif (is_array($attr_value) && $attr_value['count'] > 1) {
-        $tokens[$pre . ldap_server_massage_text($attr_name, 'attr_name', LDAP_SERVER_MASSAGE_TOKEN_REPLACE) . LDAP_SERVERS_TOKEN_DEL . 'last' . $post] = check_plain($attr_value[$attr_value['count']-1]);
-        for ($i=0; $i<$attr_value['count']; $i++) {
+        $tokens[$pre . ldap_server_massage_text($attr_name, 'attr_name', LDAP_SERVER_MASSAGE_TOKEN_REPLACE) . LDAP_SERVERS_TOKEN_DEL . 'last' . $post] = check_plain($attr_value[$attr_value['count'] - 1]);
+        for ($i = 0; $i < $attr_value['count']; $i++) {
           $tokens[$pre . ldap_server_massage_text($attr_name, 'attr_name', LDAP_SERVER_MASSAGE_TOKEN_REPLACE) . LDAP_SERVERS_TOKEN_DEL . $i . $post] = check_plain($attr_value[$i]);
         }
       }
